Scriptname maxMagicDriveScript extends activemagiceffect  

import Utility

float Property Energy Auto 

Spell Property Drive01  Auto
Spell Property Drive02  Auto
Spell Property MaxDrive  Auto

Spell Property WeakDrive01  Auto
Spell Property WeakDrive02  Auto
Spell Property WeakMaxDrive  Auto

Spell Property OverDrive01  Auto
Spell Property OverDrive02  Auto
Spell Property OverMaxDrive  Auto

Idle Property Drive01Idle  Auto  
Idle Property Drive02Idle  Auto  
Idle Property MaxDriveIdle  Auto  

maxQuestScript Property maxQuest  Auto  

ObjectReference Property AirWalk  Auto

Sound Property Rapid01  Auto  
Sound Property Rapid02  Auto  
Sound Property Rapid03  Auto  

Event OnEffectStart(Actor Target, Actor Caster)

	Actor PlayerActor =  Game.GetPlayer()

	if PlayerActor.getAV("oneHanded") as float > PlayerActor.getAV("twoHanded") as float

		Energy = PlayerActor.getAV("oneHanded") as float

	else

		Energy = PlayerActor.getAV("twoHanded") as float

	endif

	Energy *= 0.5

	if PlayerActor.IsWeaponDrawn() && !PlayerActor.IsFlying() && maxQuest.TriggerOff  == 0

;		AirWalk.Enable()
;		AirWalk.moveTo(PlayerActor,0 ,0 ,0)

		if PlayerActor.getAV("health") as float / PlayerActor.getBaseAV("health") as float < 0.2

			if maxQuest.indexTrigger == 0

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive01Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.64)
				OverDrive01.Cast(PlayerActor)
				Rapid02.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0
		
			elseif maxQuest.indexTrigger == 1

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive02Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.88)
				OverDrive02.Cast(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0

			else

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(MaxDriveIdle)
				Debug.ToggleCollisions()

				Utility.wait(1.12)
				OverMaxDrive.Cast(PlayerActor)
				Rapid01.play(PlayerActor)
				Rapid02.play(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger = 0
				maxQuest.TriggerOff  = 0

			endif
	
		elseif PlayerActor.getav("Stamina") as float < Energy

			if maxQuest.indexTrigger == 0

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive01Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.64)
				WeakDrive01.Cast(PlayerActor)
				Rapid02.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0
		
			elseif maxQuest.indexTrigger == 1

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive02Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.88)
				WeakDrive02.Cast(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0

			else

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(MaxDriveIdle)
				Debug.ToggleCollisions()

				Utility.wait(1.12)
				WeakMaxDrive.Cast(PlayerActor)
				Rapid01.play(PlayerActor)
				Rapid02.play(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger = 0
				maxQuest.TriggerOff  = 0

			endif

			Energy = PlayerActor.getav("Stamina") as float
			PlayerActor.damageAV("Stamina", Energy)

		else

			if maxQuest.indexTrigger == 0

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive01Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.64)
				Drive01.Cast(PlayerActor)
				Rapid02.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0
		
			elseif maxQuest.indexTrigger == 1

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(Drive02Idle)
				Debug.ToggleCollisions()

				Utility.wait(0.88)
				Drive02.Cast(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger += 1
				maxQuest.TriggerOff  = 0

			else

				maxQuest.TriggerOff  = 1

				Debug.ToggleCollisions()
				PlayerActor.PlayIdle(MaxDriveIdle)
				Debug.ToggleCollisions()

				Utility.wait(1.12)
				MaxDrive.Cast(PlayerActor)
				Rapid01.play(PlayerActor)
				Rapid02.play(PlayerActor)
				Rapid03.play(PlayerActor)

				maxQuest.indexTrigger = 0
				maxQuest.TriggerOff  = 0

			endif

			PlayerActor.damageAV("Stamina", Energy)

		endif

		Utility.wait(2)
;		AirWalk.Disable()

	endif

EndEvent





